
//Skye Bender-deMoll draft translation code 2/13/01
//skyebend@bennington.edu

package PajekConverter;

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.io.*;
import java.util.*;
import java.awt.color.*;

// THIS BUILDS THE GUI, THE LISTENERS RUN THE PROGRAM

public class PajekConverter extends Frame implements ActionListener, WindowListener
{

	//create window objects for later use
	//data window
	public TextArea InputDisplay;
	//status window
	public TextArea StatusDisplay;
	//button parse text to DataEntry object
	public Button ParseButton;
	//button to clear text window
	public Button ResetButton;
	//button to ouput text to file
	public Button ExportButton;
	//button to output partition
	public Button PartButton;
	//button to ouput vector
	public Button VectorButton;
	//text fields and lables
	//public TextField FilterField;
	//public Label FilterLabel;
	public TextField IdColField;
	public Label IdColLabel;
	public TextField LinkIdColField;
	public Label LinkIdColLabel;
	public TextField LabelColField;
	public Label LabelColLabel;
	public TextField ShapeColField;
	public Label ShapeColLabel;
	public TextField SizeColField;
	public Label SizeColLabel;
	public TextField NodeColorColField;
	public Label NodeColorColLabel;
	public TextField XColField;
	public Label XColLabel;
	public TextField YColField;
	public Label YColLabel;
	public TextField ArcColorColField;
	public Label ArcColorColLabel;
	public TextField ArcWidthColField;
	public Label ArcWidthColLabel;
	public TextField ArcWeightColField;
	public Label ArcWeightColLabel;
	public Label ColAssignLabel;
	public Checkbox IgnoreRowOne;

//--------GLOBAL PARAMS ----------------------------------

	//global vars
	private String outputFileName;				//name of output file
	private String outputPathName;				//location to write file to
	String defaultName = "convertedData";		//default filename for export
	String suffix = ".net";						//file suffix for export
	private Vector nodes = new Vector();	//holdes DataEntry objects
	private int nextNodeId = 1;					//holds id of next node between parses
	private boolean parsed = false;				//says whether current text has been parsed
	//private String filterName = "none";
	//spreadsheet column mappings
	private int idCol = 0;
	private int linkIdCol = 0;
	private int labelCol = 0;
	private int shapeCol = 0;
	private int sizeCol = 0;
	private int nodeColorCol = 0;
	private int xCol = 0;
	private int yCol = 0;
	private int arcColorCol = 0;
	private int arcWidthCol = 0;
	private int arcWeightCol =0;
	private int numCols = 0;    //number of cols containing valid data
	private int numAbsAttributes = 0;   //number of node attributes with absolute rather than col adress
	String[] absAttributes = new String[9];   //holds absolute attribute values

// ------ INTERFACE CONSTRUCTION AND INSTANTIATION -----------------------------

	public PajekConverter(){

		//LAYOUT
		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(5,5,5,5);

		//INSTANTIATE WINDOW COMPONENTS
		//column mapping fields and labels
		//FilterField = new TextField(filterName,10);
		//FilterLabel = new Label("FILTER",Label.RIGHT);
		IdColField = new TextField(idCol+"",4);
		IdColLabel = new Label("ID",Label.RIGHT);
		LinkIdColField = new TextField(linkIdCol+"",4);
		LinkIdColLabel = new Label("LinkID",Label.RIGHT);
		LabelColField = new TextField(labelCol+"",4);
		LabelColLabel = new Label("NodeLabel",Label.RIGHT);
		ShapeColField = new TextField(shapeCol+"",4);
		ShapeColLabel = new Label("NodeShape",Label.RIGHT);
		SizeColField = new TextField(sizeCol+"",4);
		SizeColLabel = new Label("NodeSize",Label.RIGHT);
		NodeColorColField = new TextField(nodeColorCol+"",4);
		NodeColorColLabel = new Label("NodeColor",Label.RIGHT);
		XColField = new TextField(xCol+"",4);
		XColLabel = new Label("Xcoord",Label.RIGHT);
		YColField = new TextField(yCol+"",4);
		YColLabel = new Label("Ycoord",Label.RIGHT);
		ArcColorColField = new TextField(arcColorCol+"",4);
		ArcColorColLabel = new Label("ArcColor",Label.RIGHT);
		ArcWidthColField = new TextField(arcWidthCol+"",4);
		ArcWidthColLabel = new Label("ArcWidth",Label.RIGHT);
		ArcWeightColField = new TextField(arcWeightCol+"",4);
		ArcWeightColLabel = new Label("ArcWeight",Label.RIGHT);
		ColAssignLabel = new Label("Column Assignments:",Label.RIGHT);



		//text areas and buttons
		InputDisplay = new TextArea(25,75);
		StatusDisplay = new TextArea(10,75);
		ParseButton = new Button("Parse Text");
		ResetButton = new Button("Reset/Clear network");
		ExportButton = new Button("Export network...");
		PartButton = new Button("Export partition...");
		VectorButton = new Button("Export vector...");
		IgnoreRowOne = new Checkbox("Ignore first row (column headings)",true);

		// add components to the layout GBlayout using constraints
		//text areas
		c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=12;c.weightx=0.5;c.weighty=0.0;
		add(InputDisplay,c);
		c.gridx=0;c.gridy=12;c.gridwidth=1;c.gridheight=1;c.weightx=0.0;c.weighty=0.0;
		add(IgnoreRowOne,c);
		c.gridx=0;c.gridy=13;c.gridwidth=1;c.gridheight=5;c.weightx=0.5;c.weighty=0.0;
		add(StatusDisplay,c);
		//buttons
		c.gridx=1;c.gridy=13;c.gridwidth=2;c.gridheight=1;c.weightx=0.5;c.weighty=0.0;
		add(ParseButton,c);
		c.gridx=1;c.gridy=14;c.gridwidth=2;c.gridheight=1;c.weightx=0.5;c.weighty=0.0;
		add(ExportButton,c);
		c.gridx=1;c.gridy=15;c.gridwidth=2;c.gridheight=1;c.weightx=0.5;c.weighty=0.0;
		add(PartButton,c);
		c.gridx=1;c.gridy=16;c.gridwidth=2;c.gridheight=1;c.weightx=0.5;c.weighty=0.0;
		add(VectorButton,c);
		c.gridx=1;c.gridy=17;c.gridwidth=2;c.gridheight=1;c.weightx=0.5;c.weighty=0.0;
		add(ResetButton,c);
		//fields and lables
		//c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;c.weightx=0.0;c.weighty=0.0;
		//add(FilterLabel,c);
		//c.gridx=2;c.gridy=0;
		//add(FilterField,c);
		c.gridx=1;c.gridy=0;c.weighty=0.0;c.gridwidth=2;
		add(ColAssignLabel,c);c.gridwidth=1;
		c.gridx=1;c.gridy=1;
		add(IdColLabel,c);
		c.gridx=2;c.gridy=1;
		add(IdColField,c);
		c.gridx=1;c.gridy=2;
		add(LinkIdColLabel,c);
		c.gridx=2;c.gridy=2;
		add(LinkIdColField,c);
		c.gridx=1;c.gridy=3;
		add(LabelColLabel,c);
		c.gridx=2;c.gridy=3;
		add(LabelColField,c);
		c.gridx=1;c.gridy=4;
		add(ShapeColLabel,c);
		c.gridx=2;c.gridy=4;
		add(ShapeColField,c);
		c.gridx=1;c.gridy=5;
		add(SizeColLabel,c);
		c.gridx=2;c.gridy=5;
		add(SizeColField,c);
		c.gridx=1;c.gridy=6;
		add(NodeColorColLabel,c);
		c.gridx=2;c.gridy=6;
		add(NodeColorColField,c);
		c.gridx=1;c.gridy=7;
		add(XColLabel,c);
		c.gridx=2;c.gridy=7;
		add(XColField,c);
		c.gridx=1;c.gridy=8;
		add(YColLabel,c);
		c.gridx=2;c.gridy=8;
		add(YColField,c);
		c.gridx=1;c.gridy=9;
		add(ArcColorColLabel,c);
		c.gridx=2;c.gridy=9;
		add(ArcColorColField,c);
		c.gridx=1;c.gridy=10;
		add(ArcWidthColLabel,c);
		c.gridx=2;c.gridy=10;
		add(ArcWidthColField,c);
		c.gridx=1;c.gridy=11;
		add(ArcWeightColLabel,c);
		c.gridx=2;c.gridy=11;
		add(ArcWeightColField,c);


		//add action listeners for button clicks
		ParseButton.addActionListener(this);
		ExportButton.addActionListener(this);
		PartButton.addActionListener(this);
		VectorButton.addActionListener(this);
		ResetButton.addActionListener(this);
		//add text lister for text changes
		InputDisplay.addTextListener(new TextChangeListener());
		//add window listener to handle close box
		addWindowListener(this);

		// put initial values in fields to aid user
		InputDisplay.setText("PajekConverter v1.0\n\nBasic Instructions:\n\n- Paste tab-deliniated data to parse in this window.\n\n- Enter column assignments in the fields on the right.\n\t(to enter a specific value rather than a reletive adress,\n\tprefix entry with \"$\". ex. \"$ellipse\" or \"$Red\" or \"$0.5\".)\n\n- Click \"Parse Text\"\n\n- Click one of the export buttons.\n\nFor more information, see file PajekConvertReadMe.txt\n\n\nWritten by Skye Bender-deMoll for John Padgett, University of Chicago.\n Questions/Bugs to skyebend@santafe.edu\n\nUSE AT YOUR OWN RISK ;-)\n\nJuly 4, 2001 ");

		setBackground(Color.lightGray);
	}

	//MAIN puts it all on screen
	public static void main (String[] args){
			Frame frm = new PajekConverter();
			frm.setSize (725,700);
			frm.setTitle ("PajekConverter v1.0");
			frm.setVisible (true);
	}
//-------- PARSING OPERATIONS METHODS ------------------------------------

	//puts null chars inbetween tabs so that tokenizer will work properly
	public String preformat(String workString)
	{
		char tab = ("\t").charAt(0);
		char seperator = ("_").charAt(0);
		//String workString = InputDisplay.getText();
		char[] origArray = workString.toCharArray();
		char[] newArray = new char[workString.length()*2];
		int newIndex = 0;
		//replace double tabs with tab _ tab
		for (int index = 0; index <(workString.length()-1); index++)
		{
			if ((origArray[index] == tab) && (origArray[index+1] == tab))
			{
				newArray[newIndex] = origArray[index];
				newIndex++;
				newArray[newIndex] = seperator;
				newIndex++;
			}
			else
			{
				newArray[newIndex] = origArray[index];
				newIndex++;
			}
		}
		newArray[newIndex] = workString.charAt(workString.length()-1);
		String returnString = new String(newArray);

		return returnString;
	}


	public void parse()
	{
		//reset globals so there will not be conflicts
		nodes.clear();
		nextNodeId = 1;
		numCols=0;
		numAbsAttributes = 0;
		absAttributes = new String[9];
		parsed = false;

		String statusText = "Parsing text...\n";  //holds error msgs and updates
		StatusDisplay.append(statusText);

		//read in values from col fields
		//if col field contains a string starting with "$", parseField will make that the attribute
		//otherwise it returns the col assigment
		//filterName = FilterField.getText();
		idCol = parseField(IdColField.getText());
		linkIdCol = parseField(LinkIdColField.getText());
		labelCol = parseField(LabelColField.getText());
		shapeCol = parseField(ShapeColField.getText());
		sizeCol = parseField(SizeColField.getText());
		nodeColorCol = parseField(NodeColorColField.getText());
		xCol = parseField(XColField.getText());
		yCol = parseField(YColField.getText());
		arcColorCol = parseField(ArcColorColField.getText());
		arcWidthCol = parseField(ArcWidthColField.getText());
		arcWeightCol = parseField(ArcWeightColField.getText());

		//get text from textarea and set up tokenizer
		String textToParse = InputDisplay.getText();
		StringTokenizer rowTokenizer = new StringTokenizer(textToParse, "\n");

		//if "ignore first row" is checked, dump the first row
		if (IgnoreRowOne.getState())
		{
			if (rowTokenizer.hasMoreTokens()) //make sure there is one to dump
			{
				String dump = (String)rowTokenizer.nextToken();
			}
		}

		Vector rowCache = new Vector();  //holds rows to be parsed
		//make text to explain parsing cols
		//InputDisplay.setText("Line#\tId\tLabel\tLinkId\tShape\tSize\tColor\tX\tY\tOutput?\tError?\tErrors\n");

		//parse rows into the row cache
		while (rowTokenizer.hasMoreTokens())
		{
			String line = (String)rowTokenizer.nextToken();
			if(line != null){
				line = preformat(line);
				rowCache.add(line);
			}
		}

		//check which filter is set and instantiate appropriate dataChecker
		DefaultChecker dataChecker = new DefaultChecker(rowCache.size());

		//parse each line
		for (int i = 0; i<rowCache.size(); i++)
		{
			StringTokenizer tokenizer = new StringTokenizer((String)rowCache.get(i),"\t");
			//check that there are the correct number of cols
			if (tokenizer.countTokens() < numCols)
			{
				StatusDisplay.append("ERROR: Line "+i+" is missing columns.\n");
			}
			else
			{
				 //holds items parsed from each i for easy access and speed
				String[] stringCache = new String[1+9+numCols];

				//(extra entry in [] will return "default" will have all the unused variable redirected
				//to it as is a kludgy way of hadling them
				stringCache[0] = "default";

				//stick absolue attribute value assigments on the beginning the cache so they can be adressed
				for (int a=0; a<numAbsAttributes; a++)
				{
					stringCache[1+a] = absAttributes[a];
				}
				//copy string tokens from the tokenizer to the cache so that they will have
				//numeric adresses.
				for (int j=0; j<numCols; j++)
				{
					stringCache[1+9+j] = (String)tokenizer.nextToken();
				}



				//send line to data checker using i mappings, send parse errors to statusdisplay
				statusText += dataChecker.parseRow(i, stringCache[idCol], stringCache[linkIdCol], stringCache[labelCol],
						stringCache[shapeCol], stringCache[sizeCol], stringCache[nodeColorCol],
						stringCache[xCol], stringCache[yCol], stringCache[arcColorCol], stringCache[arcWidthCol],
						stringCache[arcWeightCol]);

				//send parsed info to input display for debugging
				StatusDisplay.setText(statusText +"Rows parsed:"+i+"\n");
			}
		}
		//create networkAssembler object with data from dataChecker, and id to start with
		DefaultNetAssembler assembler = new DefaultNetAssembler((DefaultDataEntry)dataChecker.getData(),nextNodeId);


		//set up shapes, send errors to satus display
		StatusDisplay.append(assembler.setupShape());

		//set up size ,send errors to status display
		StatusDisplay.append(assembler.setupSize());

		//set up color,send errors to status display
		StatusDisplay.append(assembler.setupColor());

		//set up arc colrs and send errors to status display
		StatusDisplay.append(assembler.setupArcColor());

		//set up x and y coords,send errors to status display
		StatusDisplay.append(assembler.setupCoords());
//EDGES

		//ask assembler to create the nodes with lables, set otther vals, send errors to status display
		StatusDisplay.append(assembler.makeNodes());


		//create network structure send errors to status dispaly
		StatusDisplay.append(assembler.makeArcs());

		//copy all nodes to ArrayList
		nodes.addAll(assembler.getNodes());

		StatusDisplay.append("Parsing Complete, (click Export to write file)\n");
		parsed = true;
	}

	public void reset()
	{

		InputDisplay.setText("");
		StatusDisplay.setText("");
		nodes.clear();
		nextNodeId = 1;
		numCols=0;
		numAbsAttributes = 0;
		absAttributes = new String[9];
		parsed = false;
	}

	public void export()
	{
		//check if data objects represent current text window
		if (parsed == false)
		{
			StatusDisplay.append("Text must be parsed before output. \n");
		}
		else
		{

//CONSTRUCT TEXT FORMMATTED FOR PAJEK -----------
			String vertHeader = "*Vertices "+nodes.size()+"\r";
			String arcHeader = "*Arcs\r";
			StringBuffer vertBody = new StringBuffer(75*nodes.size()); //start with approx  capcity to
			StringBuffer arcBody = new StringBuffer(25*nodes.size());  //try and cut memory hanleing costs

			//display
			String statusText = StatusDisplay.getText()+"Nodes Exported:";

			for (int i=0; i<nodes.size(); i++)
			{
				PajekNode workNode = (PajekNode)nodes.get(i);
				vertBody.append(workNode.toPajekNodeString());
				arcBody.append(workNode.toPajekArcString());
				//show id of node as it is exported
				StatusDisplay.setText(statusText+(i+1)+"\n");
			}
			String outString = vertHeader+vertBody+arcHeader+arcBody;

// GET FILE NAME FOR OUTPUT -----------------------
			//bring up save dialog to get names for file output, but do not open file yet
			FileDialog locateOutput = new FileDialog(this, "Enter file name and choose directory for data output", FileDialog.SAVE);

			//throw up open dialog
			locateOutput.setSize(450,300);
			locateOutput.setFile(defaultName+suffix);
			locateOutput.setVisible(true);
			outputFileName = locateOutput.getFile();
			outputPathName = locateOutput.getDirectory();

//WRITE TEXT TO FILE -----------------------------
			//check if user canceled save dialog don't output data to flie (but still do to screen)
			if ((outputFileName != null) && (outputPathName != null))
			{
				//report file status to status area
				StatusDisplay.append("Exporting parsed text to file: "+ outputPathName + outputFileName+"\n");

				//create new file (default family name?)
				try
				{
					//give fileobject name and path from dialog	globals
					File outfile = new File(outputPathName, outputFileName);
					//make new outputstream
					FileOutputStream outStream = new FileOutputStream(outfile);
					//make new printwrinter
					PrintWriter outWriter = new PrintWriter(outStream,true);

					//ask printwriter to output string to file
					outWriter.println(outString);

					//close connection to file
					outStream.close();
					StatusDisplay.append("Export Complete\n");

				}catch (IOException error)
				{
					StatusDisplay.append("Error saving output file " + error.toString()+"\n");
				}
			}
		}
		//reset vals
		/*
		nodes.clear();
		nextNodeId = 1;
		numCols=0;
		numAbsAttributes = 0;
		absAttributes = new String[9];
		StatusDisplay.append("Data cleared, ready for new network.\n");
		*/
	}

//EXPORT PARTITION DIALOG -----------------------------------
	public void exportPartDialog()
	{
		//throw up dialog asking which node var to export
		Dialog whichVar = new Dialog(this, "Choose node attribute to export as Partition",true);
		whichVar.setSize(500,75);
		whichVar.setLocation(225,550);
		//make new layout
		whichVar.setLayout(new GridBagLayout());

		//make objects for layout and add listeners
		Button CancelButton = new Button("Cancel");
		CancelButton.addActionListener(this);
		Button OkButton = new Button("Export Partition");
		OkButton.addActionListener(this);
		CheckboxGroup cbg = new CheckboxGroup();
		//put components in window
		whichVar.add(new Checkbox("Node Label", cbg, true));
		whichVar.add(new Checkbox("Node Shape", cbg, false));
      	whichVar.add(new Checkbox("Node Color", cbg, false));
		whichVar.add(OkButton);
		whichVar.add(CancelButton);
		//put it on screen
		whichVar.show();
	}
//EXPORT PARTITION ------------------------------------------------
	public void exportPart(String varToExport)
	{
		if (parsed == false)
		{
			StatusDisplay.append("Text must be parsed before output. \n");
		}
		else
		{
			StatusDisplay.append("Assembling partition...\n");
			//assmeble data
			String vertHeader = "*Vertices "+nodes.size()+"\r";
			StringBuffer vertBody = new StringBuffer(5*nodes.size()); //start with approx  capcity to
			String[] textArray = new String[nodes.size()];   //hold strings comming from nodes
			int nextClass = 1;
			Hashtable textToClass = new Hashtable();   //holds text to class associations

	//LABEL
			if (varToExport.equals("Node Label"))
			{
				for (int i=0; i<nodes.size(); i++)
				{
					//copy from nodes into textArray
					textArray[i] = ((PajekNode)nodes.elementAt(i)).getLabel();
				}
			}
	//SHAPE
			if (varToExport.equals("Node Shape"))
			{
				for (int i=0; i<nodes.size(); i++)
				{
					//copy from nodes into textArray
					textArray[i] = ((PajekNode)nodes.elementAt(i)).getShape();
				}
			}
	//COLOR
			if (varToExport.equals("Node Color"))
			{
				for (int i=0; i<nodes.size(); i++)
				{
					//copy from nodes into textArray
					textArray[i] = ((PajekNode)nodes.elementAt(i)).getColor();
				}
			}

			//convert text to class int
			for (int i=0; i<nodes.size(); i++)
			{
				//if the label is already used, copy class to classArray
				if (textToClass.containsKey(textArray[i]))
				{
					vertBody.append("   "+ (Integer)textToClass.get(textArray[i])+"\r");
				}
				else
				{
					textToClass.put(textArray[i],(new Integer(nextClass)));
					nextClass++;
					vertBody.append("   "+ (Integer)textToClass.get(textArray[i])+"\r");
				}
			}

			String outString = vertHeader+vertBody;
			//debug
			//InputDisplay.setText(outString);

		// GET FILE NAME FOR OUTPUT -----------------------
			//bring up save dialog to get names for file output, but do not open file yet
			FileDialog locateOutput = new FileDialog(this, "Enter file name and choose directory for data output", FileDialog.SAVE);

			//throw up open dialog
			locateOutput.setSize(450,300);
			locateOutput.setFile("nodePartition.clu");
			locateOutput.setVisible(true);
			outputFileName = locateOutput.getFile();
			outputPathName = locateOutput.getDirectory();

		//WRITE TEXT TO FILE -----------------------------
			//check if user canceled save dialog don't output data to flie (but still do to screen)
			if ((outputFileName != null) && (outputPathName != null))
			{
				//report file status to status area
				StatusDisplay.append("Exporting partition to file: "+ outputPathName + outputFileName+"\n");

				//create new file (default family name?)
				try
				{
					//give fileobject name and path from dialog	globals
					File outfile = new File(outputPathName, outputFileName);
					//make new outputstream
					FileOutputStream outStream = new FileOutputStream(outfile);
					//make new printwrinter
					PrintWriter outWriter = new PrintWriter(outStream,true);

					//ask printwriter to output string to file
					outWriter.println(outString);

					//close connection to file
					outStream.close();
					StatusDisplay.append("Partition saved.\n");

				}catch (IOException error)
				{
					StatusDisplay.append("Error saving partition file " + error.toString()+"\n");
				}
			}
		}
	}
//EXPORT VECTOR DIALOG -------------------------------------------------
	public void exportVectorDialog()
	{
		//throw up dialog asking which node var to export
		Dialog whichVar = new Dialog(this, "Choose node attribute to export as Vector",true);
		whichVar.setSize(500,75);
		whichVar.setLocation(225,575);
		//make new layout
		whichVar.setLayout(new GridBagLayout());

		//make objects for layout and add listeners
		Button CancelButton = new Button("Cancel");
		CancelButton.addActionListener(this);
		Button OkButton = new Button("Export Vector");
		OkButton.addActionListener(this);
		CheckboxGroup cbg = new CheckboxGroup();
		//put components in window
		whichVar.add(new Checkbox("Node Size", cbg, true));
		whichVar.add(new Checkbox("X coordinate", cbg, false));
		whichVar.add(new Checkbox("Y coordinate", cbg, false));
		whichVar.add(OkButton);
		whichVar.add(CancelButton);
		//put it on screen
		whichVar.show();
	}
//EXPORT VECTOR - ------------------------------------------------------------------
	public void exportVector(String varToExport)
	{
		if (parsed == false)
		{
			StatusDisplay.append("Text must be parsed before output. \n");
		}
		else
		{
			StatusDisplay.append("Assembling vector...\n");
			//assmeble data
			String vertHeader = "*Vertices "+nodes.size()+"\r";
			StringBuffer vertBody = new StringBuffer(5*nodes.size()); //start with approx  capcity to

	//SIZE
			if (varToExport.equals("Node Size"))
			{
				for (int i=0; i<nodes.size(); i++)
				{
					//copy size from nodes
					vertBody.append("   "+((PajekNode)nodes.elementAt(i)).getSize()+"\r");
				}
			}
	//X
			if (varToExport.equals("X coordinate"))
			{
				for (int i=0; i<nodes.size(); i++)
				{
					//copy x coord from nodes
					vertBody.append("   "+((PajekNode)nodes.elementAt(i)).getXCoord()+"\r");
				}
			}
	//Y
			if (varToExport.equals("Y coordinate"))
			{
				for (int i=0; i<nodes.size(); i++)
				{
					//copy y coord from nodes
					vertBody.append("   "+((PajekNode)nodes.elementAt(i)).getYCoord()+"\r");
				}
			}


			String outString = vertHeader+vertBody;
			//debug
			//InputDisplay.setText(outString);

		// GET FILE NAME FOR OUTPUT -----------------------
			//bring up save dialog to get names for file output, but do not open file yet
			FileDialog locateOutput = new FileDialog(this, "Enter file name and choose directory for data output", FileDialog.SAVE);

			//throw up open dialog
			locateOutput.setSize(450,300);
			locateOutput.setFile("nodeVector.vec");
			locateOutput.setVisible(true);
			outputFileName = locateOutput.getFile();
			outputPathName = locateOutput.getDirectory();

		//WRITE TEXT TO FILE -----------------------------
			//check if user canceled save dialog don't output data to flie (but still do to screen)
			if ((outputFileName != null) && (outputPathName != null))
			{
				//report file status to status area
				StatusDisplay.append("Exporting vector to file: "+ outputPathName + outputFileName+"\n");

				//create new file (default family name?)
				try
				{
					//give fileobject name and path from dialog	globals
					File outfile = new File(outputPathName, outputFileName);
					//make new outputstream
					FileOutputStream outStream = new FileOutputStream(outfile);
					//make new printwrinter
					PrintWriter outWriter = new PrintWriter(outStream,true);

					//ask printwriter to output string to file
					outWriter.println(outString);

					//close connection to file
					outStream.close();
					StatusDisplay.append("vector saved.\n");

				}catch (IOException error)
				{
					StatusDisplay.append("Error saving vector file " + error.toString()+"\n");
				}
			}
		}
	}


	//------------ UTILITY METHODS --------------------------------------

	//parse field takes text and returns a column assigment.  If text starts with
	//"$", it makes the text the attribute. returns 0 if unable to parse
	public int parseField(String str)
	{
		int returnInt = 0;
		str.trim();
		if(str.startsWith("$"))
		{
			// trim off $
			str = str.substring(1,str.length());
			//put string in abs attributes array
			absAttributes[numAbsAttributes] = str;
			//give adress for "dummy" col
			returnInt = numAbsAttributes+1;
			//increment
			numAbsAttributes++;
		}
		else
		{
			try
			{
				returnInt = new DecimalFormat().parse(str).intValue();
			}
			catch(ParseException e)
			{
			}
			//numCols equal the largest value parsed
			if (returnInt > numCols)
			{
					numCols = returnInt;
			}

			//if it was a genuine col assiment, add the offset of 10
			if (returnInt != 0)
			{
				returnInt += 9;
			}
		{

		}


		}
		return returnInt;
	}


	//ACTION PERFORMED gets the name of the button clicked and calls the aproprate method
	public void actionPerformed(ActionEvent evt)
	{
		Button btn = (Button)evt.getSource();
		String whichBtn = btn.getLabel();
		if(whichBtn.equals("Parse Text"))
		{
			parse();
		}
		if(whichBtn.equals("Export network..."))
		{
			export();
		}
		if(whichBtn.equals("Export partition..."))
		{
			exportPartDialog();
		}
		if(whichBtn.equals("Export vector..."))
		{
			exportVectorDialog();
		}
		if(whichBtn.equals("Reset/Clear network"))
		{
			reset();
		}
		if(whichBtn.equals("Cancel"))
		{
			((Dialog)btn.getParent()).dispose();
		}
		if(whichBtn.equals("Export Partition"))
		{
			//figure out which option was checked
			String checked = ((((Checkbox)((Dialog)btn.getParent()).getComponent(1)).getCheckboxGroup()).getSelectedCheckbox()).getLabel();
			exportPart(checked);
			((Dialog)btn.getParent()).dispose();
		}
		if(whichBtn.equals("Export Vector"))
		{
			//figure out which option was checked
			String checked = ((((Checkbox)((Dialog)btn.getParent()).getComponent(1)).getCheckboxGroup()).getSelectedCheckbox()).getLabel();
			exportVector(checked);
			((Dialog)btn.getParent()).dispose();
		}


	}
	//TEXT AREA LISTENER  indicates that object representation of the text may no longer be valid
	class TextChangeListener implements TextListener {
		public void textValueChanged(TextEvent e){
			if((e.getID() == TextEvent.TEXT_VALUE_CHANGED))
			{
				//parsed = false;
			}
		}
	}

	//WINDOW LISTENERS windowClosing closes window when close box is clicked
	//the rest just have to be there I Guess...
	public void windowClosing (WindowEvent evt){
		  System.exit(0);
	}

	public void windowActivated(WindowEvent evt){}
	public void windowClosed(WindowEvent evt){}
	public void windowDeactivated(WindowEvent evt){}
	public void windowDeiconified(WindowEvent evt){}
	public void windowIconified(WindowEvent evt){}
	public void windowOpened(WindowEvent evt){}

}

